
local mode, world, gamescore = ...

if mode == "debug" then world = "basic" gamescore = {} end

runfile("chat.lua", _G)

local furtherbg = CreateFrame("Sprite")
furtherbg:SetTexture("star_bg")
furtherbg:SetPoint("CENTER", UIParent, "CENTER")
furtherbg:SetLayer(-1002)

local starbg = CreateFrame("Frame")
starbg:SetLayer(-1001)

local uipbg = CreateFrame("Sprite")
uipbg:SetTexture("star_room")
uipbg:SetPoint("CENTER", UIParent, "CENTER")
uipbg:SetLayer(-1000)

local pieces = CreateFrame("RenderSorter")
pieces:SetLayer(-1)

local grid = CreateFrame("Frame")
grid:SetLayer(-2)

local next_zone = CreateFrame("Frame")
next_zone:SetWidth(300)
next_zone:SetHeight(300 / 1.6)
next_zone:SetBackgroundColor(0, 0, 0, 0.2)
next_zone:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 30, 410)
next_zone:SetLayer(-2)
local next_text = CreateFrame("Text", next_zone)
next_text:SetColor(1, 1, 1)
next_text:SetPoint("CENTER", next_zone, 0.4, 0.25)
next_text:SetText("Next piece:")
next_zone:Hide()

local anchors = {}
table.insert(anchors, CreateFrame("Frame", next_zone))
table.insert(anchors, CreateFrame("Frame", next_zone))
table.insert(anchors, CreateFrame("Frame", next_zone))
table.insert(anchors, CreateFrame("Frame", next_zone))
table.insert(anchors, CreateFrame("Frame", next_zone))
anchors[1]:SetPoint("CENTER", next_zone, 7/8, 0.25)
anchors[2]:SetPoint("CENTER", next_zone, 7/8, 0.75)
anchors[3]:SetPoint("CENTER", next_zone, 5/8, 0.75)
anchors[4]:SetPoint("CENTER", next_zone, 3/8, 0.75)
anchors[5]:SetPoint("CENTER", next_zone, 1/8, 0.75)

local Point
do
  local point_meta = {}
  function point_meta.__add(x, y)
    assert(type(x) == "table" and getmetatable(x) == point_meta)
    assert(type(y) == "table" and getmetatable(y) == point_meta)
    return Point(x[1] + y[1], x[2] + y[2], x[3] + y[3])
  end
  function point_meta.__sub(x, y)
    assert(type(x) == "table" and getmetatable(x) == point_meta)
    assert(type(y) == "table" and getmetatable(y) == point_meta)
    return Point(x[1] - y[1], x[2] - y[2], x[3] - y[3])
  end
  function point_meta.__mul(x, d)
    assert(type(d) == "number")
    return Point(x[1] * d, x[2] * d, x[3] * d)
  end
  
  Point = function(x, y, z)
    return setmetatable({x, y, z}, point_meta)
  end
end
local function lerp(s, y, d)
  assert(type(s) == type(y))
  if type(s) == "number" then
    return s * d + y * (1 - d)
  elseif type(s) == "table" then
    return Point(lerp(s[1], y[1], d), lerp(s[2], y[2], d), lerp(s[3], y[3], d))
  else
    assert(false)
  end
end
local function cross(a, b)
  return Point(a[2] * b[3] - a[3] * b[2], a[3] * b[1] - a[1] * b[3], a[1] * b[2] - a[2] * b[1])
end
local function norm(a)
  local l = math.sqrt(a[1] * a[1] + a[2] * a[2] + a[3] * a[3])
  return Point(a[1] / l, a[2] / l, a[3] / l)
end

-- fuck coding it, we're just going to model it
local function parseTriangles(text, tx, ty, tz, sx, sy, sz)
  local tris = {}
  
  local pts = {}
  for txt in text:match("point %[([^%]]*)%]"):gmatch("([0123456789-][^,]*)") do
    local x, y, z = txt:match("([%d%.-]+) ([%d%.-]+) ([%d%.-]+)")
    x, y, z = tonumber(x), tonumber(y), tonumber(z)
    assert(x and y and z)
    
    table.insert(pts, Point((x + tx) * sx, (y + ty) * sy, (z + tz) * sz))
  end
  print("---")
  print(text:match("coordIndex %[([^%]]*)%]"))
  for txt in text:match("coordIndex %[([^%]]*)%]"):gmatch("([X0123456789][^\n]*), %-1,") do
    local flagged = nil
    if txt:sub(1, 1) == "X" then
      flagged = true
      txt = txt:sub(2)
    end
    
    local x, y, z, q
    x, y, z, q = txt:match("(%d+), (%d+), (%d+), (%d+)")
    if q then
      -- quad
      table.insert(tris, {pts[x + 1], pts[y + 1], pts[z + 1], flagged = flagged})
      table.insert(tris, {pts[x + 1], pts[z + 1], pts[q + 1], flagged = flagged})
    else
      x, y, z = txt:match("(%d+), (%d+), (%d+)")
      assert(x and y and z)
      table.insert(tris, {pts[x + 1], pts[y + 1], pts[z + 1], flagged = flagged})
    end
  end
  
  return tris
end

local function mirror(item)
  local ct = #item
  for i = 1, ct do
    local pts = {}
    for k = 1, 3 do
      table.insert(pts, Point(-item[i][k][1], item[i][k][2], item[i][k][3]))
    end
    local tt = pts[1]
    pts[1] = pts[2]
    pts[2] = tt
    pts.flagged = item[i].flagged
    table.insert(item, pts)
  end
end

local function gen_pieces(chunk)
  local out = {}
  for d = 1, 6 do
    local ang = d * 3.14159 / 3
    local xdx, xdy = math.sin(ang), math.cos(ang)
    local ydx, ydy = math.cos(ang), -math.sin(ang)
    print(d, xdx, xdy, ydx, ydy)
    
    local choonk = {}
    for _, v in ipairs(chunk) do
      local tri = {}
      for _, p in ipairs(v) do
        table.insert(tri, Point(xdx * p[1] + ydx * p[2], xdy * p[1] + ydy * p[2], p[3]))
        if math.abs(p[1]) + math.abs(p[2]) < 0.01 then
          tri.segment = 0
        end
      end
      tri.lightable = not v.flagged
      table.insert(choonk, tri)
    end
    table.insert(out, choonk)
  end
  return out
end

local connected = parseTriangles([[Coordinate3 {
			point [
				 -0.507500 0.856649 -0.008842,
				 -0.471910 0.794044 0.095131,
				 -0.007500 -0.009376 0.045131,
				 -0.007500 0.856649 -0.008842,
				 -0.007500 0.794344 0.045131,
				 -0.097091 0.145806 0.045131,
				 -0.097091 0.856649 -0.008842,
				 -0.097091 0.794286 0.045131,
				 -0.124015 0.192370 0.095131,
				 -0.125809 0.856649 -0.008842,
				 -0.125809 0.794268 0.095131,
				 -0.007500 0.192257 0.045131,
				 -0.097091 0.192403 0.045131,
				 -0.007500 0.146071 0.045131,
			]
		}
		IndexedFaceSet {
			coordIndex [
				 X 7, 4, 3, 6, -1,
				 X 10, 1, 8, -1,
				 X 9, 0, 1, 10, -1,
				 10, 7, 6, 9, -1,
				 7, 12, 11, 4, -1,
				 12, 8, 5, -1,
				 12, 7, 10, 8, -1,
				 13, 5, 2, -1,
				 13, 11, 12, 5, -1,
			]
		}]], 0.007500, 0.009376, 0.008842, 1.01, 1.01, 2)
mirror(connected)

local conn_pieces = gen_pieces(connected)

local disc = parseTriangles([[Coordinate3 {
			point [
				 -0.507500 0.856649 -0.008842,
				 -0.471910 0.794044 0.095131,
				 -0.007500 -0.009376 0.045131,
				 -0.007500 0.856649 -0.008842,
				 -0.007500 0.794344 0.095131,
				 -0.097091 0.145806 0.045131,
				 -0.097091 0.856649 -0.008842,
				 -0.097091 0.794286 0.095131,
				 -0.124015 0.192370 0.095131,
				 -0.125809 0.856649 -0.008842,
				 -0.125809 0.794268 0.095131,
				 -0.007500 0.192257 0.095131,
				 -0.097091 0.192403 0.095131,
				 -0.007500 0.146071 0.045131,
			]
		}
		IndexedFaceSet {
			coordIndex [
				 7, 4, 3, 6, -1,
				 10, 1, 8, -1,
				 9, 0, 1, 10, -1,
				 10, 7, 6, 9, -1,
				 7, 12, 11, 4, -1,
				 12, 8, 5, -1,
				 12, 7, 10, 8, -1,
				 13, 5, 2, -1,
				 13, 11, 12, 5, -1,
			]
		}]], 0.007500, 0.009376, 0.008842, 1.01, 1.01, 2)
mirror(disc)

local disc_pieces = gen_pieces(disc)

-- mirror


--[[
-- fuck modeling it, we're just going to code it
for ang = 0, 5 do
  local inset = 0.1
  local slope = 0.5
  local height = inset * slope
  
  local depression = 0.5 * inset
  local start_depression = 0.2
  local end_depression = 0.3
  
  local height_mid = depression * slope
  
  local function radip(ta, dist, height)
    return lerp(Point(math.cos(3.14159 / 3 * ang) * dist, math.sin(3.14159 / 3 * ang) * dist, height), Point(math.cos(3.14159 / 3 * (ang + 1)) * dist, math.sin(3.14159 / 3 * (ang + 1)) * dist, height), ta)
  end
  
  -- outer edge
  table.insert(tris, {radip(0, 1 - inset, height), radip(1, 1 - inset, height), radip(0, 1, 0)})
  table.insert(tris, {radip(1, 1 - inset, height), radip(1, 1, 0), radip(0, 1, 0)})
  
  -- top segment
  table.insert(tris, {radip(0, 1 - inset, height), radip(0, 0, height), radip(1, 1 - inset, height)})
end
]]

local bg_lighting = 1.0
local sphere_lighting = 1.0
local path_lighting = 1.0
local shiny_lighting = 1.0

local base_prog
do
  local vertex = glutil.Shader("VERTEX", [[
    uniform bool glow_mask[7];
    attribute float segment;
    attribute float lightable;
    
    varying float lighting;
    varying vec2 tex;
    varying float glow;
    varying float z;
    
    void main()
    {
      gl_Position = ftransform();
      
      vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
      vec3 lightDir = normalize(vec3(1.0, -2.0, 1.0));
      
      lighting = -dot(normal, lightDir) * 0.9 + 0.1;
      
      gl_TexCoord[0].st = gl_Vertex.xy;
      
      if(bool(lightable) && glow_mask[int(segment)])
        glow = gl_Vertex.z;
      else
        glow = 100.0;
      
      z = gl_Vertex.z;
    }
  ]])
  local fragment = glutil.Shader("FRAGMENT", [[
    uniform sampler2D wood;
    
    varying float lighting;
    varying float glow;
    varying float z;

    uniform float background_lighting;
    uniform float path_lighting;
    
    void main()
    {
      float glow_amount = max(0.0, min(0.5, (0.2 - glow) * 4.0));
      float fade_amount;
      if(z > 0.107 && z < 0.108)
        fade_amount = 0.5;
      else
        fade_amount = 1.0;
      
      gl_FragColor = vec4((1.0 - glow_amount) * fade_amount * lighting * texture2D(wood, gl_TexCoord[0].st).rgb * background_lighting + glow_amount * vec3(1.0, 1.0, 0.5) * 1.5 * path_lighting, 1.0);
    }
  ]])
  base_prog = glutil.Program()
  glutil.AttachShader(base_prog, vertex)
  glutil.AttachShader(base_prog, fragment)
  glutil.LinkProgram(base_prog)
  glutil.VertexAttribInit(base_prog, "segment")
  glutil.VertexAttribInit(base_prog, "lightable")
end

local sphere_prog
do
  local vertex = glutil.Shader("VERTEX", [[
    varying float lighting;
    
    void main()
    {
      gl_Position = ftransform();
      
      vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
      vec3 lightDir = normalize(vec3(1.0, -2.0, 1.0));
      
      lighting = dot(normal, lightDir) * 0.9 + 0.1;
    }
  ]])
  local fragment = glutil.Shader("FRAGMENT", [[
    uniform bool glow;
    uniform vec3 color;
    
    varying float lighting;
    
    uniform float background_lighting;
    uniform float sphere_lighting;
    
    void main()
    {
      vec3 stdlight = lighting * color * background_lighting;
      vec3 glowlight = color * sphere_lighting;
      
      if(glow) {
        gl_FragColor = vec4(stdlight * 0.2 + glowlight, 1.0);
      } else {
        gl_FragColor = vec4(stdlight * 0.6 + glowlight * 0.1, 1.0);
      }
    }
  ]])
  sphere_prog = glutil.Program()
  glutil.AttachShader(sphere_prog, vertex)
  glutil.AttachShader(sphere_prog, fragment)
  glutil.LinkProgram(sphere_prog)
end

local shine_prog
do
  local vertex = glutil.Shader("VERTEX", [[
    varying vec2 pos;
    attribute vec3 color;
    
    varying vec3 frag_color;
    attribute vec2 points;
    
    attribute float cycle_length;
    varying float cycle_length_var;
    
    uniform bool fancytrans;
    
    void main()
    {
      if(fancytrans) {
        float scale = distance(gl_ModelViewProjectionMatrix * vec4(0.0, 0.0, 0.0, 0.0), gl_ModelViewProjectionMatrix * vec4(1.0, 0.0, 0.0, 0.0));
        //scale = 0.1;
        mat4 project = gl_ModelViewProjectionMatrix;
        project[0][0] = scale; project[1][0] = 0.0; project[2][0] = 0.0;
        project[0][1] = 0.0; project[1][1] = scale; project[2][1] = 0.0;
        project[0][2] = 0.0; project[1][2] = 0.0; project[2][2] = scale;
        gl_Position = project * gl_Vertex;
      } else {
        gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
      }
      
      pos = points;
      frag_color = color;
      cycle_length_var = cycle_length;
    }
  ]])
  local fragment = glutil.Shader("FRAGMENT", [[
    varying vec2 pos;
    varying vec3 frag_color;
    
    uniform float time;
    varying float cycle_length_var;
    
    uniform float background_lighting;
    uniform float shiny_lighting;
    
    uniform float star_factor;
    
    void main()
    {
      float po = star_factor;
      vec2 scap = pow(abs(pos), vec2(po, po));
      float len = pow(scap.x + scap.y, 1.0 / po);
      
      // MUST end up >= 1.0
      float scaley = 1.0;
      
      // downsize from the flicker loop
      float flicker_downsize = 2.0;
      scaley *= (sin(time / cycle_length_var * 3.14159 * 2.0) / flicker_downsize + (1.0 + 1.0 / flicker_downsize));
      scaley = sqrt(scaley);
      
      // controls to change when the lights go out
      scaley *= 1.0 + 0.75 * background_lighting;
      float light_intensity_scale = 1.0 - 0.25 * background_lighting;
      
      gl_FragColor = vec4(frag_color * max(1.0 - len * scaley, 0.0) * light_intensity_scale * shiny_lighting, 1.0);
      
      //gl_FragColor = vec4(1.0, 1.0, 1.0, 1.0);
    }
  ]])
  shine_prog = glutil.Program()
  glutil.AttachShader(shine_prog, vertex)
  glutil.AttachShader(shine_prog, fragment)
  glutil.LinkProgram(shine_prog)
  glutil.VertexAttribInit(shine_prog, "color")
  glutil.VertexAttribInit(shine_prog, "points")
  glutil.VertexAttribInit(shine_prog, "cycle_length")
end


pieces:SetShaderPriority(base_prog, 0)
pieces:SetShaderPriority(shine_prog, 1)
pieces:SetShaderPriority(sphere_prog, 1)


local tim = 0

local Piece
do
  local function rotate(x, y, rot)
    local xdx, xdy = math.sin(rot), math.cos(rot)
    local ydx, ydy = math.cos(rot), -math.sin(rot)
    
    return xdx * x + ydx * y, xdy * x + ydy * y
  end
  
  local function mkpt(round, up, size)
    local x, y, z = size, 0, 0
    x, z = rotate(x, z, up / 2 * 3.14159)
    x, y = rotate(x, y, round * 3.14159 * 2)
    return Point(x, y, z)
  end
  
  function peez_Draw(self)
    gl.MatrixMode("MODELVIEW")
    gl.PushMatrix()
    gl.Rotate(self.rot * 60, 0, 0, 1)
    
    RenderSort(base_prog, function ()
      glutil.UniformI(base_prog, "wood", 0)
      glutil.UniformI(base_prog, "glow_mask[0]", self.state[0] == "active" and 1 or 0)
      glutil.UniformI(base_prog, "glow_mask[1]", self.state[1] == "active" and 1 or 0)
      glutil.UniformI(base_prog, "glow_mask[2]", self.state[2] == "active" and 1 or 0)
      glutil.UniformI(base_prog, "glow_mask[3]", self.state[3] == "active" and 1 or 0)
      glutil.UniformI(base_prog, "glow_mask[4]", self.state[4] == "active" and 1 or 0)
      glutil.UniformI(base_prog, "glow_mask[5]", self.state[5] == "active" and 1 or 0)
      glutil.UniformI(base_prog, "glow_mask[6]", self.state[6] == "active" and 1 or 0)
      
      glutil.UniformF(base_prog, "background_lighting", bg_lighting)
      glutil.UniformF(base_prog, "path_lighting", path_lighting)
      
      glutil.Autolist(self, "drawlist_base", function ()
        gl.Color(1, 1, 1)
        Texture("wood"):SetTexture()
        gl.Begin("TRIANGLES")
        local lsegment = nil
        local llightable = nil
        for id = 1, 6 do
          local chun
          if self.state[id] == "close" then
            chun = disc_pieces[id]
          else
            chun = conn_pieces[id]
          end
        
          for _, v in pairs(chun) do
            local tsegment = v.segment or id
            local tlightable = v.lightable and 1 or 0
            if tsegment ~= lsegment then glutil.VertexAttrib(base_prog, "segment", tsegment) end
            if tlightable ~= llightable then glutil.VertexAttrib(base_prog, "lightable", tlightable) end
            lsegment, llightable = tsegment, tlightable
            local norm = cross(v[2] - v[1], v[3] - v[1])
            gl.Normal(norm)
            for i = 1, 3 do
              gl.Vertex(v[i])
            end
          end
        end
        gl.End()
        SetNoTexture()
      end)
    end)
    
    if self.daddy.sphere then
      RenderSort(sphere_prog, function ()
        glutil.UniformF(sphere_prog, "color", self.daddy.sphere_r, self.daddy.sphere_g, self.daddy.sphere_b)
        glutil.UniformI(sphere_prog, "glow", self.daddy.distance and 1 or 0)
        glutil.UniformF(sphere_prog, "background_lighting", bg_lighting)
        glutil.UniformF(sphere_prog, "sphere_lighting", sphere_lighting)
        glutil.Autolist(self, "drawlist_sphere", function ()
          gl.Begin("QUADS")
          for round = 1, 16 do
            for deep = 0, 4 do
              local points = {
                mkpt((round + 0) / 16, (deep + 0) / 4 + 0.01, self.daddy.sphere_size),
                mkpt((round + 1) / 16, (deep + 0) / 4 + 0.01, self.daddy.sphere_size),
                mkpt((round + 1) / 16, (deep + 1) / 4 + 0.01, self.daddy.sphere_size),
                mkpt((round + 0) / 16, (deep + 1) / 4 + 0.01, self.daddy.sphere_size)
              }
              
              local norm = cross(points[2] - points[1], points[3] - points[1])
              
              gl.Normal(norm)
              for i = 1, 4 do
                gl.Vertex(points[i])
              end
            end
          end
          gl.End()
        end)
      end)
    else
      if self.daddy.distance then
        RenderSort(shine_prog, function ()
          glutil.UniformF(shine_prog, "time", tim)
          glutil.UniformF(shine_prog, "background_lighting", bg_lighting)
          glutil.UniformF(shine_prog, "shiny_lighting", shiny_lighting)
          glutil.Autolist(self, "drawlist_shine", function ()
            glutil.UniformI(shine_prog, "fancytrans", 1.0)
            glutil.UniformF(shine_prog, "star_factor", 0.5)
            gl.BlendFunc("ONE", "ONE")
            gl.Begin("QUADS")
            for _, v in pairs(self.daddy.shines) do
              glutil.VertexAttrib(shine_prog, "color", v.color[1], v.color[2], v.color[3])
              glutil.VertexAttrib(shine_prog, "cycle_length", v.cycle_length)
              glutil.VertexAttrib(shine_prog, "points", -1, -1)
              gl.Vertex(v.x - v.sizex, v.y - v.sizey, 1.0)
              glutil.VertexAttrib(shine_prog, "points", 1, -1)
              gl.Vertex(v.x + v.sizex, v.y - v.sizey, 1.0)
              glutil.VertexAttrib(shine_prog, "points", 1, 1)
              gl.Vertex(v.x + v.sizex, v.y + v.sizey, 1.0)
              glutil.VertexAttrib(shine_prog, "points", -1, 1)
              gl.Vertex(v.x - v.sizex, v.y + v.sizey, 1.0)
            end
            gl.End()
            gl.BlendFunc("SRC_ALPHA", "ONE_MINUS_SRC_ALPHA")
          end)
        end)
      end
    end
    
    gl.PopMatrix()
  end

  function Piece(connectors)
    local fram = CreateFrame("Frame", pieces)
    
    local drix = CreateFrame("Frame", fram)
    drix:SetAllPoints(fram)
    drix.state = {"close", "close", "close", "close", "close", "close"}
    
    for i = 1, 6 do
      if connectors[i] then drix.state[i] = "open" end
    end
    drix.state[0] = "open"
    
    function fram:SetEnables(ena)
      local actives = false
      for i = 1, 6 do
        local enid = rotate_mod(i - drix.rot_approach, 6)
        if drix.state[i] == "close" then
          if ena[enid] then drix.state[i] = "active" end
          --assert(not ena[i])
        else
          drix.state[i] = ena[enid] and "active" or "open"
          if ena[enid] then actives = true end
        end
      end
      drix.state[0] = actives and "active" or "open"
    end
    drix.rot = 0
    drix.rot_approach = 0
    drix:SetCoordinateScale(0, 0, 0.866649 * 2)
    
    drix.Draw = peez_Draw
    drix.daddy = fram  -- siiigh

    function drix:Tick()
      self.rot = approach(self.rot, self.rot_approach, 0.2)
    end
    function fram:rotate_left()
      drix.rot_approach = drix.rot_approach - 1
    end
    function fram:rotate_right()
      drix.rot_approach = drix.rot_approach + 1
    end
    function fram:is_connected(x)
      return connectors[rotate_mod(x + drix.rot_approach, 6)]
    end
    
    
    --[[
    local texargh = CreateFrame("Text", fram)
    texargh:SetPoint("CENTER", fram, "CENTER")
    texargh:SetText("?")
    texargh:SetLayer(1000)
    texargh:SetColor(1, 1, 1)
    function fram:SetArgh(tex)
      texargh:SetText(tostring(tex))
    end]]
    
    local ct = math.random(3, 5)
    local bshine = {}
    local bshinedist = 0
    for try = 1, 4 do
      local tshine = {}
      local tshinedist = 0
      for i = 1, ct do
        table.insert(tshine, {x = (math.random() * 2 - 1) * 0.5, y = (math.random() * 2 - 1) * 0.5, color = {math.random() / 2 + 0.5, math.random() / 2 + 0.5, math.random() / 2 + 0.5}, sizex = math.random() * 0.4 + 0.4, sizey = math.random() * 0.4 + 0.4, cycle_length = math.random() * 2 + 2})
      end
      
      for x = 1, ct do
        for y = x + 1, ct do
          local dx, dy = tshine[x].x - tshine[y].x, tshine[x].y - tshine[y].y
          tshinedist = tshinedist + dx * dx + dy * dy
        end
      end
      
      if tshinedist > bshinedist then
        bshinedist = tshinedist
        bshine = tshine
      end
    end
    fram.shines = bshine
    
    
    return fram
  end
end

local gridx = 45
local gridy = gridx * (1.5 / 0.866024 / 2)

local piece_layouts = {
  basic = {
    core = 1,
    terminator = 29,
    connector_2 = 10,
    connector_3 = 30,
    connector_4 = 20,
    connector_5 = 10
  },
  straight = {
    core = 1,
    terminator = 19,
    connector_2 = 45,
    connector_3 = 25,
    connector_4 = 10,
  },
  split = {
    core = 1,
    terminator = 49,
    connector_2 = 0,
    connector_3 = 10,
    connector_4 = 30,
    connector_5 = 10
  }
}
local pieces = piece_layouts[world]

local piececount = 100

--[[
if mode == "debug" then
  pieces = {
    core = 1,
    terminator = 1,
    connector_2 = 1,
    connector_3 = 0,
    connector_4 = 0,
    connector_5 = 0,
  } piececount = 3
end

assert(pieces)]]

do
  local pct = 0
  for k, v in pairs(pieces) do
    pct = pct + v
  end
  print(pct, "pieces")
  assert(pct == piececount)
end
local function gen_connections(ct)
  local con = {1, 2, 3, 4, 5, 6}
  local access = {false, false, false, false, false, false}
  
  local lct
  for i = 1, ct do
    lct = table.remove(con, math.random(#con))
    access[lct] = true
  end
  
  local pc = Piece(access)
  pc.last_item = lct
  
  return pc
end
local piece_funcs = {
  core = function ()
    local peez = Piece({true, true, false, false, false, false})
    peez.sphere = true
    peez.sphere_r, peez.sphere_g, peez.sphere_b = 1, 1, 1
    peez.sphere_size = 0.3
    peez.distance = 0
    return peez
  end,
  terminator = function ()
    local peez = gen_connections(1)
    peez.sphere = true
    while true do
      peez.sphere_r, peez.sphere_g, peez.sphere_b = (math.random(2) - 1) * 0.5, (math.random(2) - 1) * 0.5, (math.random(2) - 1) * 0.5
      if peez.sphere_r ~= peez.sphere_g or peez.sphere_r ~= peez.sphere_b then break end
    end
    peez.sphere_size = 0.5
    return peez
  end,
  connector_2 = function ()
    return gen_connections(2)
  end,
  connector_3 = function ()
    return gen_connections(3)
  end,
  connector_4 = function ()
    return gen_connections(4)
  end,
  connector_5 = function ()
    return gen_connections(5)
  end,
}
local function gentyp(k)
  local ite = piece_funcs[k]()
  ite.type = k
  ite:SetWidth(gridx)
  ite:SetHeight(gridy)
  return ite
end
local function get_set()
  print("Generating layout")
  local piec = {}
  for k, v in pairs(pieces) do
    if k ~= "core" then
      for i = 1, v do
        table.insert(piec, gentyp(k))
      end
    end
  end
  local core = gentyp("core")
  
  while true do
    local oat = {}
    local piecbase = {}
    for _, v in pairs(piec) do table.insert(piecbase, v) end
    table.insert(oat, core)
    
    while #piecbase > 0 do table.insert(oat, table.remove(piecbase, math.random(#piecbase))) end
    
    if oat[piececount].type ~= "terminator" then continue end
    if oat[piececount].last_item == 1 or oat[piececount].last_item == 2 then continue end
    
    if piececount == 100 then
      local exp_termcount = (pieces.terminator + 1) / 10
      local count
      
      count = 0
      for i = 1, 5 do if oat[i].type == "terminator" then count = count + 1 end end
      if count > 1 then continue end
      
      count = 0
      for i = 1, 10 do if oat[i].type == "terminator" then count = count + 1 end end
      if count > exp_termcount then continue end
      
      count = 0
      for i = 91, 100 do if oat[i].type == "terminator" then count = count + 1 end end
      if count > exp_termcount then continue end
    end
    
    print("Done generating layout")
    return oat
  end
end

--[[
our hex is 0.866024 radius wide, or 0.866024*2=1.73205 wide

we condense that to 1, so we're scaling everything down by a factor of 1.73205

^   -- y 1
 \
  \
  *  -- y 0.5
  |
  |
  |
  *  -- y -0.5
  /
 /
V  -- y -1

hex is effectively 1.5 units high
]]

local function testagainst(x, y, tx, ty)
  if math.abs(y - ty) < 1 / 1.5 then
    -- we're within the area where the solid area impacts
    return math.abs(x - tx) < 0.99
  elseif math.abs(y - ty) < 2 / 1.5 then
    -- we're up in the tapers
    return math.abs(x - tx) < 0.99 * (2 - math.abs(y - ty) * 1.5)
  else
    return false
  end
end

local function grid_from_draw(x, y)
  return x + y / 2 + 0.5
end
local function draw_from_grid(x, y)
  return x - y / 2 - 0.5
end

local function bumping(x, y, matrix)
  local ylit = math.floor(y)
  local yfract = y - ylit
  
  local leftwall = testagainst(x, y, draw_from_grid(0, ylit), ylit)
  local rightwall = testagainst(x, y, draw_from_grid(ylit + 1, ylit), ylit)
  
  local blwall = testagainst(x, y, draw_from_grid(0, ylit - 1), ylit - 1)
  local brwall = testagainst(x, y, draw_from_grid(ylit, ylit - 1), ylit - 1)
  
  local xadj = math.round(grid_from_draw(x, ylit))
  local around = false
  for dx = -1, 1 do
    for dy = -1, 1 do
      local rx, ry = xadj + dx, ylit + dy
      if matrix[ry] and matrix[ry][rx] then
        local testy = testagainst(x, y, draw_from_grid(rx, ry), ry)
        if testy then around = true end
      end
    end
  end
  
  return leftwall or rightwall or blwall or brwall or around
end

--local dx, dy = {0, 1, 1, 0, -1, -1}, {1, 1, 0, -1, -1, 0}
local dx, dy = {1, 0, -1, -1, 0, 1}, {1, 1, 0, -1, -1, 0}

local items = get_set()
for _, v in pairs(items) do
  v:Hide()
end
local leftrepeat = false
local rightrepeat = false
local doshit = coroutine.wrap(function ()
  if world == "basic" then
    ShowConvo{
      {"mcdougal", "Behold, my latest magnificent creation! Born of wire and wood, I call it: the ELECTROTREE!"},
      {"apprentice", ". . . Wha?"},
      {"mcdougal", "Mounted upside-down to facilitate construction, it shall be a modern marvel of Christmas."},
      {"apprentice", "Christmas . . . last month?"},
      {"mcdougal", "ABSOLUTELY! And, as it is so uselessly late, I shall leave it to you to finish construction. I have lost interest in the project entirely."},
      {"apprentice", "Me?"},
      {"mcdougal", "I assume you have read the explanatory pamphlet I slipped under your door before awakening you?"},
      {"apprentice", "um"},
      {"mcdougal", "Hmph. No work ethic at all. Luckily for you, I brought an extra copy. Behold!"},
      {image = "instructions"},
      {"mcdougal", "That will of course answer all your questions. Begin immediately!"},
    }
    coroutine.yield()
  end
  
  next_zone:Show()
  
  local matrix = {} -- DO YOU UNDERSTAND THE MATRIX
  for row = 1, 19 do matrix[row] = {} end -- RED PILL OR BLUE PILL MOTHERFUCKER
  
  local norotate = true
  
  local report = CreateFrame("Text")
  report:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -20, 20)
  report:SetColor(1, 1, 1)
  for k = 1, piececount do
    report:SetText(("%d pieces remaining"):format(100 - k))
    print("start what")
    local citem = items[k]
    local cx, cy = 0, 18
    while bumping(cx, cy, matrix) do
      cx = math.random(-8, 8)
    end
    
    for i = 1, 5 do
      if not items[k + i] then break end
      items[k + i]:Show()
      items[k + i]:SetPoint("CENTER", anchors[i], "CENTER")
    end
    
    local landed = false
    
    citem:Show()
    while not landed do
      for i = 1, 60 do
        cy = cy - 1/60
        
        local ocx, ocy = cx, cy
        local hchange = false
        if WasKeyPressed("arrow_left") then
          cx = math.ceil(cx * 2) / 2 - 0.5
          hchange = true
        end
        if WasKeyPressed("arrow_right") then
          cx = math.floor(cx * 2) / 2 + 0.5
          hchange = true
        end
        if hchange then
          if bumping(cx, cy, matrix) then
            cx, cy = ocx, ocy
          end
        end
        
        if k ~= 1 then
          if WasKeyPressed("z") then
            citem:rotate_left()
            norotate = false
          end
          if WasKeyPressed("x") then
            citem:rotate_right()
            norotate = false
          end
        end
        if IsKeyDownFrame("arrow_down") then
          cy = cy - 10/60
        end
        
        if bumping(cx, cy, matrix) then
          for i = 1, 30 do
            if not bumping(cx + i/60, cy, matrix) then
              --print("bumping", i)
              cx = cx + i/60
              break
            end
            if not bumping(cx - i/60, cy, matrix) then
              --print("bumping", i)
              cx = cx - i/60
              break
            end
          end
          
          if bumping(cx, cy, matrix) then
            local rcx = math.round(cx * 2) / 2
            if math.abs(rcx - cx) < 0.1 and not bumping(rcx, cy, matrix) then
              cx = rcx
            end
          end
          
          if bumping(cx, cy, matrix) then
            -- must have landed
            landed = true
            
            local tx, ty = nil, math.round(cy)
            tx = grid_from_draw(math.round(cx * 2) / 2, ty)  -- this should be our actual coordinate
            if math.round(tx) ~= tx then
              print(tx, math.round(tx), tx - math.round(tx), cx, cy)
              assert(false)
            end
            
            print("land", tx, ty)
            PlaySound("clunk")
            assert(not matrix[ty][tx])
            matrix[ty][tx] = citem
            citem:SetPoint("CENTER", UIParent, "CENTER", math.round(cx * 2) / 2 * gridx, (8 - math.round(cy)) * gridy)
            break
          end
        end
        
        citem:SetPoint("CENTER", UIParent, "CENTER", cx * gridx, (8 - cy) * gridy)
        coroutine.yield()
      end
    end
    
    -- piece dropped, do everything
    
    -- first we clear the old adjacencies
    local old_engaged = 0
    for y, d in pairs(matrix) do
      for x, i in pairs(d) do
        if i.type == "terminator" and i.distance and i.live then
          old_engaged = old_engaged + 1
        end
        i.distance_old = i.distance
        i.distance = nil
        i.distance_from = nil
        i.live = nil
        i.live_items = nil
      end
    end
    
    local tdc = {}
    matrix[1][1].distance = 0
    table.insert(tdc, {1, 1, 0})
    
    while #tdc > 0 do
      local it = table.remove(tdc, 1)
      
      local ox, oy, od = unpack(it)
      
      if matrix[oy][ox].distance < od then continue end
      
      for ang = 1, 6 do
        local nx, ny = ox + dx[ang], oy + dy[ang]
        local targ = matrix[ny] and matrix[ny][nx]
        
        if targ and matrix[oy][ox]:is_connected(ang) and targ:is_connected(ang + 3) then
          if not targ.distance or targ.distance > od + 1 then
            targ.distance = od + 1
            targ.distance_from = {} -- we'll fill this in a minute
            table.insert(tdc, {nx, ny, od + 1})
          end
          
          if targ.distance == od + 1 then
            -- identical distance
            table.insert(targ.distance_from, {ox, oy, ang})
          end
        end
      end
    end
    
    -- now we trace back from nodes
    function tracert(x, y)
      if matrix[y][x].live then return end
      local highest = y
      matrix[y][x].live = true
      if not matrix[y][x].live_items then matrix[y][x].live_items = {} end
      if matrix[y][x].distance_from then
        local ct = 0
        for _, d in pairs(matrix[y][x].distance_from) do
          ct = ct + 1
          matrix[y][x].live_items[rotate_mod(d[3] + 3, 6)] = true
          if not matrix[d[2]][d[1]].live_items then matrix[d[2]][d[1]].live_items = {} end
          matrix[d[2]][d[1]].live_items[d[3]] = true
          highest = math.max(highest, tracert(d[1], d[2]))  -- actually does the work here, the highest is just a side effect
        end
        if ct > 1 then
          achievement.award(achievement.db.fork)
        end
      end
      return highest
    end
    local new_engaged = 0
    for y, d in pairs(matrix) do
      for x, i in pairs(d) do
        if i.type == "terminator" then
          local top = tracert(x, y)
          
          if i.distance and i.distance_old and i.distance_old >= i.distance + 3 then
            achievement.award(achievement.db.bypasses)
          end
          if y == 2 and top >= 14 then
            achievement.award(achievement.db.scenic)
          end
        end
        if i.type == "terminator" and i.distance and i.live then
          new_engaged = new_engaged + 1
        end
      end
    end
    
    print(new_engaged, old_engaged)
    if new_engaged > old_engaged then
      print("engaging")
      PlaySound("engage")
    end
    if new_engaged >= old_engaged + 4 then
      achievement.award(achievement.db.multiple)
    end
    
    -- now we go and mark live locations and links
    for y, d in pairs(matrix) do
      for x, i in pairs(d) do
        if i.live_items then
          i:SetEnables(i.live_items)
        else
          i:SetEnables({})
        end
      end
    end
  end
  
  report:Detach()
  next_zone:Hide()
  
  -- score things
  
  items[1].live = true  -- just in case it's not
  
  -- 1's represent the core, which is weird
  local total_ornaments = 1
  local active_ornaments = 1
  local longest_path = 1
  
  local total_hexes = 0
  local powered_hexes = 0
  local connected_hexes = 0
  
  for _, v in pairs(items) do
    if v.type == "terminator" then
      total_ornaments = total_ornaments + 1
      if v.distance then
        active_ornaments = active_ornaments + 1
        longest_path = math.max(longest_path, v.distance)
      end
    end
    
    total_hexes = total_hexes + 1
    if v.distance then connected_hexes = connected_hexes + 1 end
    if v.distance and v.live then powered_hexes = powered_hexes + 1 end
  end
  
  if active_ornaments == total_ornaments then
    achievement.award(achievement.db.shiny)
    if norotate then
      achievement.award(achievement.db.norotate)
    end
  end
  if total_hexes == connected_hexes then
    achievement.award(achievement.db.sparkly)
  end
  if total_hexes == powered_hexes then
    achievement.award(achievement.db.spectacular)
  end
  
  -- let us make some texts
  local texts = {
    {"Powered ornaments"},
    {"Powered tiles"},
    {"Connected tiles"},
    {"Longest path"},
    {"Score"}
  }
  
  local scores = CreateFrame("Frame")
  scores:SetLayer(10)
  scores:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -60, -200)
  scores:SetWidth(300)
  
  local texti = {}
  local scori = {}
  local pcnt = {}
  for i, v in pairs(texts) do
    local tex = CreateFrame("Text", scores)
    local sco = CreateFrame("Text", scores)
    local pcn = CreateFrame("Text", scores)
    tex:SetPoint("TOPLEFT", texti[i - 1] or scores, "BOTTOMLEFT", nil, i == 5 and 10 or 0)
    sco:SetPoint("TOPRIGHT", scori[i - 1] or scores, "BOTTOMRIGHT", nil, i == 5 and 10 or 0)
    pcn:SetPoint("TOPLEFT", sco, "TOPRIGHT", nil, i == 5 and 10 or 0)
    tex:SetColor(1, 1, 1)
    sco:SetColor(1, 1, 1)
    pcn:SetColor(1, 1, 1)
    tex:SetText(v[1])
    sco:SetText("100")
    pcn:SetText("%")
    table.insert(texti, tex)
    table.insert(scori, sco)
    table.insert(pcnt, pcn)
    
    tex:Hide()
    sco:Hide()
    pcn:Hide()
  end
  
  scori[1]:SetText(tostring(math.round(active_ornaments / total_ornaments * 100)))
  scori[2]:SetText(tostring(math.round(powered_hexes / total_hexes * 100)))
  scori[3]:SetText(tostring(math.round(connected_hexes / total_hexes * 100)))
  scori[4]:SetText(tostring(longest_path))
  
  local finalscore = math.round(active_ornaments / total_ornaments * powered_hexes / total_hexes * connected_hexes / total_hexes * longest_path * 100 * 100 * 100)
  if not gamescore[world] or gamescore[world] < finalscore then
    gamescore[world] = finalscore
    persistence.save()
  end
  
  local fsstr = tostring(finalscore)
  local pos = 1
  while true do
    if #fsstr >= pos * 4 then
      fsstr = fsstr:sub(1, #fsstr - pos * 4 + 1) .. "," .. fsstr:sub(#fsstr - pos * 4 + 2)
    else
      break
    end
    pos = pos + 1
  end
  scori[5]:SetText(fsstr)
  
  pcnt[4]:SetText("")
  pcnt[5]:SetText("")
  
  uipbg:SetColor(0.2, 0.2, 0.2)
  bg_lighting = 0.2
  
  sphere_lighting = 0
  path_lighting = 0
  shiny_lighting = 0
  PlaySound("switch_big")
  coroutine.pause(180)
  sphere_lighting = 1
  texti[1]:Show()
  scori[1]:Show()
  pcnt[1]:Show()
  PlaySound("switch")
  coroutine.pause(180)
  path_lighting = 0.5
  texti[2]:Show()
  scori[2]:Show()
  pcnt[2]:Show()
  PlaySound("switch")
  coroutine.pause(180)
  shiny_lighting = 1
  texti[3]:Show()
  scori[3]:Show()
  pcnt[3]:Show()
  PlaySound("switch")
  coroutine.pause(180)
  
  texti[4]:Show()
  scori[4]:Show()
  pcnt[4]:Show()
  texti[5]:Show()
  scori[5]:Show()
  pcnt[5]:Show()
  
  coroutine.pause(300)
  
  while not WasKeyPressed("z") and not WasKeyPressed("mouse_left") and not WasKeyPressed(" ") and not WasKeyPressed("enter") do coroutine.yield() end
  
  GlorpController("exit_game")
  
  while true do coroutine.yield() end -- only here for debug reasons
end)


local griddy = glutil.List()
griddy:Create()
gl.Color(0, 0, 0, 0.3)

gl.Begin("TRIANGLES")
for y = 1, 17 do
  for x = 1, y do
    local tx = draw_from_grid(x, y)
    
    local cx, cy = tx * gridx + 512, (8 - y) * gridy + 384
    
    for d = 1, 6 do
      gl.Vertex(cx, cy)
      gl.Vertex(math.sin(3.14159 * 2 / 6 * d) * gridx * 0.48 + cx, math.cos(3.14159 * 2 / 6 * d) * gridx * 0.48 + cy)
      gl.Vertex(math.sin(3.14159 * 2 / 6 * (d + 1)) * gridx * 0.48 + cx, math.cos(3.14159 * 2 / 6 * (d + 1)) * gridx * 0.48 + cy)
    end
  end
end
gl.End()
griddy:End()

function grid:Draw()
  griddy:Call()
end


local roomy = Texture("star_room")
function starbg:Draw()
  glutil.UseProgram(shine_prog)

  glutil.UniformF(shine_prog, "time", tim)
  glutil.UniformF(shine_prog, "background_lighting", bg_lighting)
  glutil.UniformF(shine_prog, "shiny_lighting", 1.0)
  
  glutil.Autolist(self, "list", function ()
    print("making stars")
    glutil.UniformI(shine_prog, "fancytrans", 0.0)
    glutil.UniformF(shine_prog, "star_factor", 0.3)
    
    gl.BlendFunc("ONE", "ONE")
    gl.Begin("QUADS")
    for i = 1, 30 do
      local bright = math.random() * 0.7
      local r, g, b = math.random() * 0.1 + 0.2 + bright, math.random() * 0.1 + 0.2 + bright, math.random() * 0.1 + 0.2 + bright
      
      local sizex, sizey = math.random() * 20 + 20, math.random() * 20 + 20
      local cycle_length = math.random() * 4 + 4
    
      local x, y
      
      while true do
        x, y = math.random(1024) - 1, math.random(768) - 1
        
        if roomy:GetPixel(x, y) == 16777215 then break end
      end
      
      glutil.VertexAttrib(shine_prog, "color", r, g, b)
      glutil.VertexAttrib(shine_prog, "cycle_length", cycle_length)
      glutil.VertexAttrib(shine_prog, "points", -1, -1)
      gl.Vertex(x - sizex, y - sizey, 1.0)
      glutil.VertexAttrib(shine_prog, "points", 1, -1)
      gl.Vertex(x + sizex, y - sizey, 1.0)
      glutil.VertexAttrib(shine_prog, "points", 1, 1)
      gl.Vertex(x + sizex, y + sizey, 1.0)
      glutil.VertexAttrib(shine_prog, "points", -1, 1)
      gl.Vertex(x - sizex, y + sizey, 1.0)
    end
    gl.End()
    gl.BlendFunc("SRC_ALPHA", "ONE_MINUS_SRC_ALPHA")
    print("done making stars")
  end)
  
  glutil.UseProgram()
end


function tick_loop(...)
  doshit()
  tim = tim + 1/60
end
local ambient = ControlSound("ambient", nil, true)
function shutdown()
  ambient:Stop()
end
