
runfile("chat.lua", _G)


bg_r, bg_g, bg_b = 0.0, 0.0, 0.0

local shakycam = CreateFrame("Frame")
shakycam:SetAllPoints()
shakycam:SetLayer(-1)

local bg = CreateFrame("Sprite", shakycam)
bg:SetTexture("bedroom")
bg:SetPoint("TOPLEFT", UIParent, "TOPLEFT")

local suppress = false

local exit_selector = CreateFrame("Frame", menu.exit_button)
exit_selector:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT")
exit_selector:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT")
exit_selector:SetHeight(180)
--exit_selector:SetBackgroundColor(1, 0, 0, 0.2)
function exit_selector:MouseIn()
  if not suppress then menu.exit_text:Show() end
end
function exit_selector:MouseOut()
  menu.exit_text:Hide()
end
menu.exit_text:SetPoint("CENTER", UIParent, "BOTTOMLEFT", 320, -100)
menu.exit_text:Hide()

local ok_selector = CreateFrame("Frame", menu.ok_button)
ok_selector:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 700, 50)
ok_selector:SetPoint("BOTTOMRIGHT", UIParent, "TOPLEFT", 970, 768 - 180)
--ok_selector:SetBackgroundColor(1, 0, 0, 0.2)
function ok_selector:MouseIn()
  if not suppress then menu.ok_text:Show() end
end
function ok_selector:MouseOut()
  menu.ok_text:Hide()
end
menu.ok_text:SetPoint("CENTER", UIParent, "CENTER", 310, -200)
menu.ok_text:SetText("Start")
menu.ok_text:Hide()

local achievement_selector = CreateFrame("Frame", menu.achievement_button)
achievement_selector:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 430, 100)
achievement_selector:SetPoint("BOTTOMRIGHT", UIParent, "TOPLEFT", 600, 300)
--achievement_selector:SetBackgroundColor(1, 0, 0, 0.2)
function achievement_selector:MouseIn()
  if not suppress then menu.achievement_text:Show() end
end
function achievement_selector:MouseOut()
  menu.achievement_text:Hide()
end
menu.achievement_text:SetPoint("CENTER", achievement_selector, "CENTER", 0, 0)
menu.achievement_text:Hide()

local scores = persistence.load("scores")
for k, v in pairs(scores) do
  print(k, v)
end
print("END SCOREDUMP")

local anim = nil

local ambient
function menu.ok_button:Click()
  menu.ok_text:Hide()
  menu.exit_text:Hide()
  menu.achievement_text:Hide()
  ok_selector.MouseIn = nil
  exit_selector.MouseIn = nil
  achievement_selector.MouseIn = nil
  menu.ok_button.Click = nil
  menu.exit_button.Click = nil
  menu.achievement_button.Click = nil
  
  tick_loop = coroutine.wrap(function ()
    local game_type = "basic"
    
    local menu = CreateFrame("Frame")
    menu:SetBackgroundColor(0, 0, 0, 0.5)
    
    local basic_button = CreateFrame("Button", menu)
    local basic_text = CreateFrame("Text", basic_button)
    basic_text:SetText("The Unveiling of the Electrotree")
    local basic_score = CreateFrame("Text", basic_button)
    
    local rp_button = CreateFrame("Button", menu)
    local rp_text = CreateFrame("Text", rp_button)
    rp_text:SetText("Roads and Pathways")
    local rp_score = CreateFrame("Text", rp_button)
    
    local orn_button = CreateFrame("Button", menu)
    local orn_text = CreateFrame("Text", orn_button)
    orn_text:SetText("Ornamentastrophe")
    local orn_score = CreateFrame("Text", orn_button)
    
    basic_text:SetColor(1, 1, 1)
    rp_text:SetColor(1, 1, 1)
    orn_text:SetColor(1, 1, 1)
    basic_score:SetColor(1, 1, 1)
    rp_score:SetColor(1, 1, 1)
    orn_score:SetColor(1, 1, 1)
    
    local siz = 40
    basic_text:SetSize(siz)
    rp_text:SetSize(siz)
    orn_text:SetSize(siz)
    basic_score:SetSize(siz)
    rp_score:SetSize(siz)
    orn_score:SetSize(siz)
    
    basic_text:SetPoint(0, 0.5, UIParent, 0.1, 0.3)
    orn_text:SetPoint(0, 0.5, UIParent, 0.1, 0.5)
    rp_text:SetPoint(0, 0.5, UIParent, 0.1, 0.7)
    
    basic_score:SetPoint(1, 0.5, UIParent, 0.9, 0.3)
    orn_score:SetPoint(1, 0.5, UIParent, 0.9, 0.5)
    rp_score:SetPoint(1, 0.5, UIParent, 0.9, 0.7)
    
    menu:SetPoint("TOPLEFT", basic_text, "TOPLEFT", -50, -50)
    menu:SetPoint("BOTTOMRIGHT", rp_score, "BOTTOMRIGHT", 50, 50)
    
    local started = false
    local function makeclick(ident)
      return function ()
        game_type = ident
        started = true
      end
    end
    
    basic_button.Click = makeclick("basic")
    
    if not scores.basic then
      rp_score:SetText("(unavailable)")
      orn_score:SetText("(unavailable)")
      
      rp_score:SetColor(0.5, 0.5, 0.5)
      orn_score:SetColor(0.5, 0.5, 0.5)
      rp_text:SetColor(0.5, 0.5, 0.5)
      orn_text:SetColor(0.5, 0.5, 0.5)
    else
      basic_score:SetText(tostring(scores.basic or ""))
      rp_score:SetText(tostring(scores.straight or ""))
      orn_score:SetText(tostring(scores.split or ""))
      
      rp_button.Click = makeclick("straight")
      orn_button.Click = makeclick("split")
    end
    
    while not started do coroutine.yield() end
    menu:Detach()
    
    coroutine.pause(30)
    
    
    local ani = CreateFrame("Sprite", bg)
    ani:SetTexture("bedroom_instruction_1")
    ani:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT")
    coroutine.pause(10)
    
    ani:SetTexture("bedroom_instruction_2")

    coroutine.pause(45)
    
    if ambient then ambient:Stop() end
    PlaySound("slam")
    ani:ClearAllPoints()
    ani:SetTexture("bedroom_omg")
    ani:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT")
    
    local awake = CreateFrame("Sprite", bg)
    awake:SetTexture("bedroom_awake")
    awake:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT")
    
    local shft = 15
    local shft_mult = 1
    for i = 1, shft do
      coroutine.pause(4)
      local ang = math.random() * 3.14159 * 2
      shakycam:SetCoordinateScale(512 + math.sin(ang) * (shft - i) * shft_mult, 384 + math.cos(ang) * (shft - i) * shft_mult, 1024)
    end
    coroutine.pause(20)
    
    ShowConvo{{"mcdougal", "Feeble apprentice! Your assistance is required! Come to the Star Tower immediately!"}}
    
    GlorpController("start_game", game_type, scores)
  end)
end

local otl = nil
function menu.achievement_button:Click()
  otl = tick_loop
  tick_loop = coroutine.wrap(function ()
    suppress = true
    achievement.display()
    tick_loop = otl
    suppress = false
  end)
  tick_loop()
end

tick_loop = coroutine.wrap(function ()
  local overlay = CreateFrame("Frame")
  overlay:SetLayer(1000)
  overlay:SetAllPoints()
  for i = 1, 30 do
    overlay:SetBackgroundColor(0, 0, 0, (30 - i) / 30)
    coroutine.yield()
  end
  ambient = ControlSound("clock", nil, true)
  overlay:Detach()
  
  while true do coroutine.yield() end -- infiniloop
end)
tick_loop()
